const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const varieties = sequelize.define(
    'varieties',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

variety_code: {
        type: DataTypes.TEXT,
      
      

      },

species: {
        type: DataTypes.TEXT,
      
      

      },

breeding_program: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  varieties.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity











    db.varieties.hasMany(db.trial_entries, {
      as: 'trial_entries_variety',
      foreignKey: {
          name: 'varietyId',
      },
      constraints: false,
    });












//end loop



    db.varieties.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.varieties.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.varieties.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.varieties.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return varieties;
};


